/*                     __                                               *\
**     ________ ___   / /  ___     Scala API                            **
**    / __/ __// _ | / /  / _ |    (c) 2002-2003, LAMP/EPFL             **
**  __\ \/ /__/ __ |/ /__/ __ |                                         **
** /____/\___/_/ |_/____/_/ | |                                         **
**                          |/                                          **
** $Id: Proxy.scala,v 1.1 2004/04/29 10:38:17 zenger Exp $
\*                                                                      */

package scala;


/** This class implements a simple proxy that forwards all calls to
 *  methods of class <code>Any</code> to another object <code>x</code>.
 *  Please note that only those methods can be forwarded that are
 *  overridable and public.
 *
 *  @author  Matthias Zenger
 *  @version 1.0, 26/04/2004
 */
class Proxy(x: Any) {
    override def hashCode(): Int = x.hashCode();
    override def equals(y: Any): Boolean = x.equals(y);
    override def toString(): String = x.toString();
}
