// $Id: Base.scala,v 1.4 2004/07/14 14:05:06 buraq Exp $

package scala.util.regexp ;

/** basic regular expressions */

trait Base {

  type regexp <: RegExp;

  abstract class RegExp {
    val isNullable:Boolean;
  }

  /** Alt( R,R,R* ) */ 
  case class  Alt(rs: regexp*)  extends RegExp {

    // check rs \in R,R,R* 
    if({ val it = rs.elements; !it.hasNext || {it.next; !it.hasNext }})
      throw new SyntaxError("need at least 2 branches in Alt");

    final val isNullable = {
      val it = rs.elements;
      while( it.hasNext && it.next.isNullable ) {}
      !it.hasNext
    }
  }
  case class  Sequ(rs: regexp*) extends RegExp {
    // check rs \in R,R* 
    if({ val it = rs.elements; !it.hasNext }) 
      throw new SyntaxError("need at least 1 item in Sequ");

    final val isNullable = {
      val it = rs.elements;
      while( it.hasNext && !it.next.isNullable ) {}
      it.hasNext
    }
  }

  case class  Star(r: regexp)   extends RegExp {
    final val isNullable = true;
  }

  case object Eps               extends RegExp {
    final val isNullable = true;
    override def toString() = "Eps";
  }

  /** this class can be used to add meta information to regexps */
  class Meta( r1:regexp )       extends RegExp {
    final val isNullable = r1.isNullable;
    def r = r1;
  }

}
